﻿using System;
using System.IO;
using System.Text;
using System.Threading;
using System.Reflection;
using System.Collections.Generic;
using System.Data;
using System.Text.RegularExpressions;

using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Plugin.Commands;
using PRoCon.Core.Players;
using PRoCon.Core.Players.Items;
using PRoCon.Core.Battlemap;
using PRoCon.Core.Maps;

namespace PRoConEvents
{
  public class CGunMaster : PRoConPluginAPI, IPRoConPluginInterface
  {
    private Random rand;
    private int lastWeaponPresetIndex;

    public CGunMaster()
    {
      this.rand = new Random();
      this.lastWeaponPresetIndex = -1;
    }

    public string GetPluginName()
    {
      return "Gun Master";
    }

    public string GetPluginVersion()
    {
      return "0.5.0.0";
    }

    public string GetPluginAuthor()
    {
      return "TimSad";
    }

    public string GetPluginWebsite()
    {
      return "";
    }

    public string GetPluginDescription()
    {
      return @"
        <h2>Description</h2>
          <p>This plugin randomizes the Gun Master weapon preset that is played each round.</p>
        <h2>Settings</h2>
        ";
    }

    public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion)
    {
      this.RegisterEvents(this.GetType().Name, "OnMaplistList", "OnMaplistGetRounds", "OnMaplistGetMapIndices", "OnRoundOver", "OnGlobalChat", "OnRunNextLevel");
    }

    public void OnPluginEnable()
    {
      this.ExecuteCommand("procon.protected.pluginconsole.write", "^bGun Master ^2Enabled!");
    }

    public void OnPluginDisable()
    {
      this.ExecuteCommand("procon.protected.pluginconsole.write", "^bGunMaster ^1Disabled =(");
    }

    public List<CPluginVariable> GetDisplayPluginVariables()
    {
      List<CPluginVariable> lstReturn = new List<CPluginVariable>();

      

      return lstReturn;
    }

    public List<CPluginVariable> GetPluginVariables()
    {
      List<CPluginVariable> lstReturn = new List<CPluginVariable>();

      

      return lstReturn;
    }

    public void SetPluginVariable(string strVariable, string strValue)
    {

    }

    private void setRandomWeaponsPreset()
    {
      int weaponPresetindex;

      if (this.lastWeaponPresetIndex != -1)
      {
        weaponPresetindex = rand.Next(9);

        while (weaponPresetindex == this.lastWeaponPresetIndex)
        {
          this.ExecuteCommand("procon.protected.pluginconsole.write", "^3^b[Gun Master] ^n^0vars.gunMasterWeaponsPreset was already set to " + weaponPresetindex.ToString() + ". Choosing another number!...");
          weaponPresetindex = rand.Next(9);
        }

        this.lastWeaponPresetIndex = weaponPresetindex;
      }
      else
      {
        weaponPresetindex = rand.Next(9);
        this.lastWeaponPresetIndex = weaponPresetindex;
      }

      this.ExecuteCommand("procon.protected.send", "vars.gunMasterWeaponsPreset", weaponPresetindex.ToString());
      this.ExecuteCommand("procon.protected.pluginconsole.write", "^3^b[Gun Master] ^n^0vars.gunMasterWeaponsPreset has been set to " + weaponPresetindex.ToString());
    }

    public override void OnMaplistList(List<MaplistEntry> lstMaplist)
    {

    }

    public override void OnMaplistGetRounds(int currentRound, int totalRounds)
    {

    }

    public override void OnMaplistGetMapIndices(int mapIndex, int nextIndex)
    {

    }

    public override void OnRoundOver(int iWinningTeamID)
    {
      this.setRandomWeaponsPreset();
    }

    public override void OnGlobalChat(string speaker, string message)
    {

    }

    public override void OnRunNextLevel()
    {
      this.setRandomWeaponsPreset();
    }

  }
}